* ram. s
*
* ramdisk for atari 520 st+
* written nov 85 by Jens-Uwe Mager
*
;9 512
;10 1024
;11 2048
;12 4096
blocks	=	4096 ;groesse in 1 Kbyte blocks

secSizeShift	equ	10
secSize			equ	1024
rdSize			equ	7
fatSize			equ	20


* offsets in die base-page

prglen		=	$c
datalen		=	$14
bsslen		=	$1c
cmdlin		=	$80

* atari globals

hdv_bpb		=	$472
hdv_rw		=	$476
hdv_media	=	$47e

drvbits 	=   $4c2

xbios		=	14
tos			=	1

keepterm	=	$31
supexec		=	38

	text

	move.l  4(sp),a6		;adresse base page
	pea     vecinit
	move.w  #supexec,-(sp)
	trap    #14
	addq.l  #6, sp
	move.l  bsslen(a6),d1
	moveq   #secSizeShift,d0			;bsslen div 512
	lsr.l   d0,d1			;nr blocks
	sub.w   datrec,d1		;nr dataenbloecke
	lsr.w   #1,d1			;nr .datencluster
	move.w  d1,numcl
	move.l  prglen(a6),d0
	add.l   datalen(a6),d0
	add.l   bsslen(a6),d0
	add.l   #256,d0
	clr.w   -(sp)			;exit code
	move.l  d0,-(sp)		;laenge
	move.w  #keepterm,-(sp)
	trap    #1

vecinit:   
	move.l	hdv_rw,oldrw+2
	move.l	#rw,hdv_rw
	move.l	hdv_bpb,oldbpb+2
	move.l	#bpb,hdv_bpb
	move.l	hdv_media,oldmedia+2
	move.l	#media,hdv_media 
	move.l	drvbits,d0 
	move.l	d0,d2
	; find free drive number
	moveq	#0,d1
drvlp:
	lsr.l	#1,d0
	bcc.s	drvfnd
	addq.w	#1,d1
	bra.s	drvlp
drvfnd:
	bset	d1,d2
	move.l	d2,drvbits	;set available drives
	move.w	d1,drive	;remember drive number
	rts

rw:	;Rwabs Bios 4
	;-> 14(sp) drive numer 0 1 2 3 etc.
	;-> 6(sp) destination buffer can be odd !
	;-> 12(sp) start block
	;-> 10(sp) number of blocks
	;-> 4(sp) read write
	;	bit 0 -> 0 read 1 write
	;	bit 1 consider media change
	;	bit 2 retry only ahdi
	;	bit 3 normal or phy mode only  ahdi
	;<- d0 result 0 no error

	move.w	drive,d0	;is it our drive?
	cmp.w	14(sp),d0
	bne		oldrw

	lea		rambase,a0
	move.l	6(sp),a1	;tos buffer
	moveq	#0,d0
	move.w	12(sp),d1	;Start block
	mulu	#secSize,d1
;	moveq	#9,d0		; *512
;	asl.l	d0,d1
	add.l	d1,a0		;add to rambase
	move.w	10(sp),d0	;nr of blocks
	move.l	a1,d2

	btst	#0,d2		;dest on odd adress? if so copy bytes
	bne.s	bytes
	;copy longs
	mulu	#secSize/16,d0
;	asl.l	#7,d0		;len *512/4
	btst	#0,5(sp)	;rwflg 
	bne.s	lwords
	exg		a0,a1
lwords:
	move.l	(a1)+,(a0)+
	move.l	(a1)+,(a0)+
	move.l	(a1)+,(a0)+
	move.l	(a1)+,(a0)+
	subq.l	#1,d0
	bne.s	lwords
	rts
bytes:
	mulu	#secSize/8,d0
;	moveq	#9,d1		;*512
;	asl.l	d1,d0		;blocks -> bytes
	btst	#0,5(sp)	;rwflg
	bne.s	bytes1
	exg		a0,a1
bytes1:
	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
	subq.l	#1,d0
	bne.s	bytes1
	rts

oldrw:
	jmp		-1

bpb:
	; Getpbp bios 7
	; ->4(sp) drive
	; <-d0 bpb structure
	move.w	drive,d0
	cmp.w	4(sp),d0
	bne.s	oldbpb
	move.l	#mybpb,d0
	rts

oldbpb:
	jmp		-1

media:
	move.w	drive,d0
	cmp.w	4(sp),d0
	bne.s	oldmedia
	moveq	#0,d0
	rts

oldmedia:
	jmp		-1

	data
drive:	dc.w	0

; bpb block
mybpb:	dc.w	secSize				;bytes per sector
clsiz:	dc.w	2					;sectors per cluster
clsizb:	dc.w	secSize*2			;bytes per cluster
rdlen:	dc.w	rdSize				;directory len in sectors
fsiz:	dc.w	fatSize				;fat size in sectors
fatrec:	dc.w	1+fatSize			;start sector of second fat
datrec:	dc.w	1+rdSize+(2*fatSize);start sector of data (boot 1 + rdlen 7 + fsiz*2 10 ) == 18
numcl:	dc.w	1
bflags:	dc.w	1					;0=12 bit fat... 1=16 fat
        bss
rambase ds.b    blocks*secSize*2

        end